#include "png.h"
#include <libpng/png.h>
#include <stdlib.h>
#include <stdio.h>

int load_png(pngdata *p, char *l)
{
  FILE *f = fopen(l, "r"); if (f == NULL) return 1;
  png_structp png_ptr = NULL;
  png_infop info_ptr = NULL;
  png_infop end_info = NULL;
  png_bytep *row_pointers;
  int w, h;
  int width, height;
  char *d;

  png_ptr = png_create_read_struct(PNG_LIBPNG_VER_STRING, NULL, NULL, NULL);
  if (png_ptr == NULL) goto err;

  info_ptr = png_create_info_struct(png_ptr); if (info_ptr == NULL) goto err;
  end_info = png_create_info_struct(png_ptr); if (end_info == NULL) goto err;

  if (setjmp(png_jmpbuf(png_ptr))) goto err;

  png_init_io(png_ptr, f);
  png_read_png(png_ptr, info_ptr,
               PNG_TRANSFORM_STRIP_16 |
               PNG_TRANSFORM_STRIP_ALPHA |
               PNG_TRANSFORM_PACKING |
               PNG_TRANSFORM_GRAY_TO_RGB,
               NULL);
  row_pointers = png_get_rows(png_ptr, info_ptr);
  width = png_get_image_width(png_ptr, info_ptr);
  height = png_get_image_height(png_ptr, info_ptr);
  p->width = width;
  p->height = height;
  p->data = malloc(width * height * 3); if (p->data == NULL) abort();
  d = p->data;
  for (h = 0; h < height; h++) for (w = 0; w < width*3; w+=3, d+=3) {
    d[0] = row_pointers[h][w];
    d[1] = row_pointers[h][w+1];
    d[2] = row_pointers[h][w+2];
  }

  png_destroy_read_struct(&png_ptr, &info_ptr, &end_info);
  fclose(f);
  fprintf(stderr, "INFO: read done width %d height %d\n", width, height);
  return 0;

err:
  if (png_ptr && info_ptr && end_info)
    png_destroy_read_struct(&png_ptr, &info_ptr, &end_info);
  else if (png_ptr && info_ptr)
    png_destroy_read_struct(&png_ptr, &info_ptr, NULL);
  else if (png_ptr)
    png_destroy_read_struct(&png_ptr, NULL, NULL);
  fclose(f);
  return 1;
}
